varying highp vec3 vNormal;
varying highp vec3 vPosition;

void main() {
	highp float dist = distance(vPosition, cameraPosition);

	gl_FragColor = vec4(
		clamp(vNormal.x * 0.5 + 0.5, 0.0, 1.0), 
		clamp(vNormal.y * 0.5 + 0.5, 0.0, 1.0), 
		(sign(vNormal.z) * (1.0 - clamp(floor(dist)/128.0, 0.0, 1.0)) * 0.5) + 0.5, 
		fract(dist));
}